=== modified file 'autogen.sh'
--- autogen.sh	2012-06-13 20:45:43 +0000
+++ autogen.sh	2012-07-23 17:35:22 +0000
@@ -8,7 +8,7 @@
 
 PKG_NAME="Update Notifier"
 
-(test -f $srcdir/configure.in \
+(test -f $srcdir/configure.ac \
   && test -f $srcdir/README) || {
     echo -n "**Error**: Directory "\`$srcdir\'" does not look like the"
     echo " top-level gnome directory"

=== modified file 'config.h.in'
--- config.h.in	2011-09-27 09:57:41 +0000
+++ config.h.in	2012-07-23 17:35:22 +0000
@@ -1,4 +1,4 @@
-/* config.h.in.  Generated from configure.in by autoheader.  */
+/* config.h.in.  Generated from configure.ac by autoheader.  */
 
 /* always defined to indicate that i18n is enabled */
 #undef ENABLE_NLS
@@ -18,9 +18,6 @@
 /* Define to 1 if you have the `dcgettext' function. */
 #undef HAVE_DCGETTEXT
 
-/* Use gnome-disk-utility */
-#undef HAVE_GDU
-
 /* Define if the GNU gettext() function is already present or preinstalled. */
 #undef HAVE_GETTEXT
 

=== renamed file 'configure.in' => 'configure.ac'
--- configure.in	2011-09-27 09:57:41 +0000
+++ configure.ac	2012-07-23 17:35:22 +0000
@@ -15,13 +15,6 @@
 
 pkg_modules="gtk+-3.0 libnotify gio-2.0 >= 2.26 x11"
 
-PKG_CHECK_EXISTS(gdu, [ HAVE_GDU=1 ])
-if test "x$HAVE_GDU" != "x"; then
-    pkg_modules="$pkg_modules gdu"
-    AC_DEFINE(HAVE_GDU, 1, [Use gnome-disk-utility])
-else
-    AC_WARN(No gnome-disk-utility, disable CD-ROM checking)
-fi
 PKG_CHECK_EXISTS(gudev-1.0, [ HAVE_GUDEV=1 ])
 if test "x$HAVE_GUDEV" != "x"; then
     pkg_modules="$pkg_modules gudev-1.0"

=== modified file 'data/apt-cdrom-check'
--- data/apt-cdrom-check	2011-03-09 15:15:15 +0000
+++ data/apt-cdrom-check	2012-07-23 17:35:22 +0000
@@ -8,7 +8,7 @@
 # 2 - dist-upgrader CD
 # 3 - addon CD
 # 4 - aptoncd media
-# (if the returncodes change, make sure to update src/gdu.c)
+# (if the returncodes change, make sure to update src/cdroms.c)
 # 
 
 mount_point="$1"

=== modified file 'debian/changelog'
--- debian/changelog	2012-07-02 17:07:43 +0000
+++ debian/changelog	2012-07-23 17:35:22 +0000
@@ -1,3 +1,9 @@
+update-notifier (0.119ubuntu16) UNRELEASED; urgency=low
+
+  * Convert from libgdu to gio's GVolumeMonitor (LP: #1028040)
+
+ -- Michael Terry <mterry@ubuntu.com>  Mon, 23 Jul 2012 13:34:43 -0400
+
 update-notifier (0.119ubuntu15) quantal; urgency=low
 
   * Undo the Python 3 conversion until python3-debian is ready

=== modified file 'debian/control'
--- debian/control	2012-07-02 17:07:43 +0000
+++ debian/control	2012-07-23 17:35:22 +0000
@@ -5,7 +5,6 @@
 Build-Depends: debhelper (>= 7.0.50~),
                libgtk-3-dev,
                libglib2.0-dev (>= 2.26),
-               libgdu-dev,
                intltool,
                libnotify-dev (>= 0.7),
                libgudev-1.0-dev,

=== modified file 'po/POTFILES.in'
--- po/POTFILES.in	2012-03-22 18:51:22 +0000
+++ po/POTFILES.in	2012-07-23 17:35:22 +0000
@@ -8,7 +8,7 @@
 data/cddistupgrader
 src/crash.c
 src/avahi.c
-src/gdu.c
+src/cdroms.c
 src/hooks.c
 src/reboot.c
 src/update.c

=== modified file 'src/Makefile.am'
--- src/Makefile.am	2011-09-29 10:01:42 +0000
+++ src/Makefile.am	2012-07-23 17:35:22 +0000
@@ -30,8 +30,8 @@
 			   release.h\
 			   uevent.c\
 			   uevent.h\
-			   gdu.c\
-			   gdu.h \
+			   cdroms.c\
+			   cdroms.h \
 			   trayappletui.h\
 			   trayappletui.c
 

=== renamed file 'src/gdu.c' => 'src/cdroms.c'
--- src/gdu.c	2011-08-10 13:46:45 +0000
+++ src/cdroms.c	2012-07-23 17:35:22 +0000
@@ -2,7 +2,6 @@
 #ifdef HAVE_CONFIG_H
 #include "config.h"
 #endif
-#ifdef HAVE_GDU
 #include <glib.h>
 #include <glib-object.h>
 
@@ -10,9 +9,7 @@
 #include <sys/wait.h>
 
 #include "update-notifier.h"
-#define GDU_API_IS_SUBJECT_TO_CHANGE
-#include <gdu/gdu.h>
-#include "gdu.h"
+#include "cdroms.h"
 
 #define CDROM_CHECKER PACKAGE_LIB_DIR"/update-notifier/apt-cdrom-check"
 
@@ -39,9 +36,10 @@
    CD_WITH_APTONCD   
 };
 
-void distro_cd_detected(UpgradeNotifier *un, 
-			int cdtype, 
-			const char *mount_point)
+static void
+distro_cd_detected(UpgradeNotifier *un,
+                   int cdtype,
+                   const char *mount_point)
 {
    GtkWidget *dialog = gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL,
 					      GTK_MESSAGE_QUESTION, 
@@ -149,11 +147,12 @@
    gtk_widget_destroy (dialog);
 }
 
-void 
-up_check_mount_point_for_packages (const char *mount_point, gpointer data)
+static void 
+check_mount_point_for_packages (const char *mount_point, gpointer data)
 {
    if (!mount_point)
       return;
+   //g_print("checking mount point %s\n", p);
 
    char *ubuntu_dir = g_strdup_printf("%s/ubuntu",mount_point);
    char *cdromupgrade = g_strdup_printf("%s/cdromupgrade",mount_point);
@@ -193,69 +192,47 @@
    g_free(cmd);
 }
 
-void 
-up_device_changed (GduPool *pool, GduDevice *device, gpointer data)
-{
-   //g_print("up_device_changed %s\n", gdu_device_get_device_file (device));
-
-   // if its a partition, do the removable check on the parent
-   GduDevice *removable = NULL;
-   if (gdu_device_is_partition(device)) {
-      removable = gdu_device_find_parent(device);
-   } else {
-      removable = device;
-      g_object_ref(device);
-   }
-
-   // check if that is a removable device
-   if (!gdu_device_is_removable(removable)) {
-      g_object_unref(removable);
-      return;
-   }
-
-   // we only care about the first mount point
-   const gchar *p = gdu_device_get_mount_path (device);
-   //g_print("checking mount point %s\n", p);
-   up_check_mount_point_for_packages (p, data);
-}
-
-
-void
-up_check_mounted_devices (GduPool *pool, gpointer data)
-{
-   GList *devices = gdu_pool_get_devices (pool);
-   
-   while(devices != NULL) {
-      up_device_changed (pool, devices->data, data);
-      devices = g_list_next(devices);
-   }
-   g_list_free(devices);
-}
-
-gboolean
-up_do_hal_init (UpgradeNotifier *un)
-{
-   GduPool *pool = gdu_pool_new ();
-   if (pool == NULL)
-      return FALSE;
-
-   g_signal_connect (pool, "device_changed", (GCallback)up_device_changed, un);
-   // now check what devices we have
-   up_check_mounted_devices(pool, un);
-
-   return TRUE;
-}
-
-
-#else
-#include <glib.h>
-
-#include "update-notifier.h"
-
-gboolean
-up_do_hal_init (UpgradeNotifier *un)
-{
-    g_warning("Detection and monitoring of CD-ROMs disabled.");
-    return FALSE;
-}
-#endif // HAVE_GUDEV
+static void
+check_one_mount (GVolumeMonitor *monitor, GMount *mount, gpointer data)
+{
+    if (!g_mount_can_eject(mount))
+         return;
+
+    GFile *root = g_mount_get_root(mount);
+    gchar *p = g_file_get_path(root);
+    check_mount_point_for_packages(p, data);
+    g_free(p);
+    g_object_unref(root);
+}
+
+static void
+check_all_mounts (GVolumeMonitor *monitor, gpointer data)
+{
+    GList *mounts = g_volume_monitor_get_mounts(monitor);
+    GList *iter;
+
+    for (iter = mounts; iter; iter = iter->next) {
+        check_one_mount(monitor, mounts->data, data);
+        g_object_unref(mounts->data);
+    }
+    g_list_free(mounts);
+}
+
+gboolean
+cdroms_init (UpgradeNotifier *un)
+{
+    static GVolumeMonitor *monitor = NULL;
+    if (monitor != NULL)
+        return TRUE;
+
+    monitor = g_volume_monitor_get();
+    if (monitor == NULL)
+        return FALSE;
+
+    g_signal_connect(monitor, "mount-added", (GCallback)check_one_mount, un);
+    g_signal_connect(monitor, "mount-changed", (GCallback)check_one_mount, un);
+    check_all_mounts(monitor, un);
+
+    return TRUE;
+}
+

=== renamed file 'src/gdu.h' => 'src/cdroms.h'
--- src/gdu.h	2010-06-01 13:28:36 +0000
+++ src/cdroms.h	2012-07-23 17:35:22 +0000
@@ -1,1 +1,1 @@
-gboolean up_do_hal_init ();
+gboolean cdroms_init ();

=== modified file 'src/update-notifier.c'
--- src/update-notifier.c	2012-03-20 21:03:59 +0000
+++ src/update-notifier.c	2012-07-23 17:35:22 +0000
@@ -40,7 +40,7 @@
 #include "update-notifier.h"
 #include "update.h"
 #include "hooks.h"
-#include "gdu.h"
+#include "cdroms.h"
 #include "reboot.h"
 #include "uevent.h"
 #include "crash.h"
@@ -648,9 +648,9 @@
         // initial check for avahi
         avahi_disabled_check();
 	
-	/* setup hal so that inserted cdroms can be checked */
-	if(!up_do_hal_init(un)) {
-	   g_warning("initializing gdu failed");
+	/* setup inserted-cdroms checker */
+	if(!cdroms_init(un)) {
+	   g_warning("initializing cdroms failed");
 	}
 
 	// init release checker

